Index: frontends/php/include/forms.inc.php
===================================================================
--- frontends/php/include/forms.inc.php	(revision 38884)
+++ frontends/php/include/forms.inc.php	(working copy)
@@ -39,12 +39,12 @@
 		$new_step	= get_request('new_step', null);
 
 		if((isset($_REQUEST['slideshowid']) && !isset($_REQUEST['form_refresh']))){
-			$slideshow_data = DBfetch(DBselect('SELECT * FROM slideshows WHERE slideshowid='.$_REQUEST['slideshowid']));
+			$slideshow_data = DBfetch(DBselect('SELECT * FROM slideshows WHERE slideshowid='.zbx_dbstr($_REQUEST['slideshowid'])));
 
 			$name		= $slideshow_data['name'];
 			$delay		= $slideshow_data['delay'];
 			$steps		= array();
-			$db_steps = DBselect('SELECT * FROM slides WHERE slideshowid='.$_REQUEST['slideshowid'].' order by step');
+			$db_steps = DBselect('SELECT * FROM slides WHERE slideshowid='.zbx_dbstr($_REQUEST['slideshowid']).' order by step');
 
 			while($step_data = DBfetch($db_steps)){
 				$steps[$step_data['step']] = array(
@@ -159,7 +159,7 @@
 		$frm_title = S_DISCOVERY_RULE;
 
 		if(isset($_REQUEST['druleid'])){
-			if( ($rule_data = DBfetch(DBselect('SELECT * FROM drules WHERE druleid='.$_REQUEST['druleid']))))
+			if( ($rule_data = DBfetch(DBselect('SELECT * FROM drules WHERE druleid='.zbx_dbstr($_REQUEST['druleid'])))))
 				$frm_title = S_DISCOVERY_RULE.' "'.$rule_data['name'].'"';
 		}
 
@@ -184,7 +184,7 @@
 			$db_checks = DBselect('SELECT dcheckid,type,ports,key_,snmp_community,snmpv3_securityname,'.
 						'snmpv3_securitylevel,snmpv3_authpassphrase,snmpv3_privpassphrase'.
 						' FROM dchecks'.
-						' WHERE druleid='.$_REQUEST['druleid']);
+						' WHERE druleid='.zbx_dbstr($_REQUEST['druleid']));
 			while($check_data = DBfetch($db_checks)){
 				$count = array_push($dchecks, array('dcheckid' => $check_data['dcheckid'], 'type' => $check_data['type'],
 						'ports' => $check_data['ports'], 'key' => $check_data['key_'],
@@ -409,7 +409,7 @@
 
 		if((isset($_REQUEST["httptestid"]) && !isset($_REQUEST["form_refresh"])) || isset($limited)){
 			$httptest_data = DBfetch(DBselect("SELECT wt.*, a.name as application ".
-				" FROM httptest wt,applications a WHERE wt.httptestid=".$_REQUEST["httptestid"].
+				" FROM httptest wt,applications a WHERE wt.httptestid=".zbx_dbstr($_REQUEST["httptestid"]).
 				" AND a.applicationid=wt.applicationid"));
 
 			$name		= $httptest_data['name'];
@@ -424,7 +424,7 @@
 			$http_password 	= $httptest_data['http_password'];
 
 			$steps		= array();
-			$db_steps = DBselect('SELECT * FROM httpstep WHERE httptestid='.$_REQUEST["httptestid"].' order by no');
+			$db_steps = DBselect('SELECT * FROM httpstep WHERE httptestid='.zbx_dbstr($_REQUEST["httptestid"]).' order by no');
 			while($step_data = DBfetch($db_steps))
 			{
 				$steps[] = $step_data;
@@ -654,14 +654,14 @@
 			$sql = 'SELECT g.* '.
 					' FROM usrgrp g, users_groups ug '.
 					' WHERE ug.usrgrpid=g.usrgrpid '.
-						' AND ug.userid='.$userid;
+						' AND ug.userid='.zbx_dbstr($userid);
 			$db_user_groups = DBselect($sql);
 
 			while($db_group = DBfetch($db_user_groups)){
 				$user_groups[$db_group['usrgrpid']] = $db_group['usrgrpid'];
 			}
 
-			$db_medias = DBselect('SELECT m.* FROM media m WHERE m.userid='.$userid);
+			$db_medias = DBselect('SELECT m.* FROM media m WHERE m.userid='.zbx_dbstr($userid));
 			while($db_media = DBfetch($db_medias)){
 				$user_medias[] = array('mediaid' => $db_media['mediaid'],
 									'mediatypeid' => $db_media['mediatypeid'],
@@ -968,7 +968,7 @@
 			$sql = 'SELECT DISTINCT u.userid '.
 						' FROM users u,users_groups ug '.
 						' WHERE u.userid=ug.userid '.
-							' AND ug.usrgrpid='.$_REQUEST['usrgrpid'];
+							' AND ug.usrgrpid='.zbx_dbstr($_REQUEST['usrgrpid']);
 
 			$db_users=DBselect($sql);
 
@@ -980,7 +980,7 @@
 					' FROM groups g '.
 						' LEFT JOIN rights r on r.id=g.groupid '.
 						' LEFT JOIN nodes n on n.nodeid='.DBid2nodeid('g.groupid').
-					' WHERE r.groupid='.$_REQUEST['usrgrpid'];
+					' WHERE r.groupid='.zbx_dbstr($_REQUEST['usrgrpid']);
 
 			$db_rights = DBselect($sql);
 			while($db_right = DBfetch($db_rights)){
@@ -1042,7 +1042,7 @@
 	$sql_where = '';
 	if($selusrgrp > 0) {
 		$sql_from = ', users_groups g ';
-		$sql_where = ' AND u.userid=g.userid AND g.usrgrpid='.$selusrgrp;
+		$sql_where = ' AND u.userid=g.userid AND g.usrgrpid='.zbx_dbstr($selusrgrp);
 	}
 	$sql = 'SELECT DISTINCT u.userid, u.alias '.
 			' FROM users u '.$sql_from.
@@ -2185,7 +2185,7 @@
 			if(isset($limited) && $type != ITEM_TYPE_HTTPTEST){
 				$frmItem->addVar('valuemapid', $valuemapid);
 				$map_name = S_AS_IS;
-				if($map_data = DBfetch(DBselect('SELECT name FROM valuemaps WHERE valuemapid='.$valuemapid))){
+				if($map_data = DBfetch(DBselect('SELECT name FROM valuemaps WHERE valuemapid='.zbx_dbstr($valuemapid)))){
 					$map_name = $map_data['name'];
 				}
 				$cmbMap = new CTextBox('valuemap_name', $map_name, 20, 'yes');
@@ -2233,7 +2233,7 @@
 
 			$sql = 'SELECT DISTINCT applicationid,name '.
 					' FROM applications '.
-					' WHERE hostid='.$hostid.
+					' WHERE hostid='.zbx_dbstr($hostid).
 					' ORDER BY name';
 			$db_applications = DBselect($sql);
 			while($db_app = DBfetch($db_applications)){
@@ -2477,7 +2477,7 @@
 		if(isset($_REQUEST['hostid'])){
 			$sql = 'SELECT applicationid,name '.
 				' FROM applications '.
-				' WHERE hostid='.$_REQUEST['hostid'].
+				' WHERE hostid='.zbx_dbstr($_REQUEST['hostid']).
 				' ORDER BY name';
 			$db_applications = DBselect($sql);
 			while($db_app = DBfetch($db_applications)){
@@ -2703,7 +2703,7 @@
 				$trigs=DBselect('SELECT t.triggerid,t.description,t.expression '.
 							' FROM triggers t,trigger_depends d '.
 							' WHERE t.triggerid=d.triggerid_up '.
-								' AND d.triggerid_down='.$_REQUEST['triggerid']);
+								' AND d.triggerid_down='.zbx_dbstr($_REQUEST['triggerid']));
 
 				while($trig=DBfetch($trigs)){
 					if(uint_in_array($trig['triggerid'],$dependencies))	continue;
@@ -2905,7 +2905,7 @@
 
 		$trigger = DBfetch(DBselect('SELECT t.*, h.* '.
 			' FROM triggers t, functions f, items i, hosts h '.
-			' WHERE t.triggerid='.$triggerid.
+			' WHERE t.triggerid='.zbx_dbstr($triggerid).
 				' AND f.triggerid=t.triggerid '.
 				' AND f.itemid=i.itemid '.
 				' AND i.hostid=h.hostid '));
@@ -3480,7 +3480,7 @@
 		if(isset($_REQUEST['maintenanceid']) && !isset($_REQUEST['form_refresh'])){
 			$sql_from = ', maintenances_hosts mh ';
 			$sql_where = ' AND h.hostid=mh.hostid '.
-							' AND mh.maintenanceid='.$_REQUEST['maintenanceid'];
+							' AND mh.maintenanceid='.zbx_dbstr($_REQUEST['maintenanceid']);
 		}
 		else{
 			$sql_from = '';
@@ -3533,7 +3533,7 @@
 		if(isset($_REQUEST['maintenanceid']) && !isset($_REQUEST["form_refresh"])){
 			$sql_from = ', maintenances_groups mg ';
 			$sql_where = ' AND g.groupid=mg.groupid '.
-							' AND mg.maintenanceid='.$_REQUEST['maintenanceid'];
+							' AND mg.maintenanceid='.zbx_dbstr($_REQUEST['maintenanceid']);
 		}
 		else{
 			$sql_from = '';
@@ -3583,7 +3583,7 @@
 			$timeperiods = array();
 			$sql = 'SELECT DISTINCT mw.maintenanceid, tp.* '.
 					' FROM timeperiods tp, maintenances_windows mw '.
-					' WHERE mw.maintenanceid='.$_REQUEST['maintenanceid'].
+					' WHERE mw.maintenanceid='.zbx_dbstr($_REQUEST['maintenanceid']).
 						' AND tp.timeperiodid=mw.timeperiodid '.
 					' ORDER BY tp.timeperiod_type ASC';
 			$db_timeperiods = DBselect($sql);
@@ -4121,7 +4121,7 @@
 			/* prepare conditions */
 			$sql = 'SELECT conditiontype, operator, value '.
 					' FROM conditions '.
-					' WHERE actionid='.$_REQUEST['actionid'].
+					' WHERE actionid='.zbx_dbstr($_REQUEST['actionid']).
 					' ORDER BY conditiontype,conditionid';
 			$db_conditions = DBselect($sql);
 			while($condition_data = DBfetch($db_conditions)){
@@ -4470,7 +4470,7 @@
 			/* prepate operations */
 			$sql = 'SELECT * '.
 					' FROM operations'.
-					' WHERE actionid='.$_REQUEST['actionid'].
+					' WHERE actionid='.zbx_dbstr($_REQUEST['actionid']).
 					' ORDER BY esc_step_from,operationtype,object,operationid';
 			$db_operations = DBselect($sql);
 
@@ -4490,14 +4490,14 @@
 
 				$operation_data['opconditions'] = array();
 
-				$sql = 'SELECT * FROM opconditions WHERE operationid='.$operation_data['operationid'];
+				$sql = 'SELECT * FROM opconditions WHERE operationid='.zbx_dbstr($operation_data['operationid']);
 				$db_opconds = DBselect($sql);
 				while($db_opcond = DBfetch($db_opconds)){
 
 					$operation_data['opconditions'][] = $db_opcond;
 				}
 
-				$sql = 'SELECT * from opmediatypes WHERE operationid='.$operation_data['operationid'];
+				$sql = 'SELECT * from opmediatypes WHERE operationid='.zbx_dbstr($operation_data['operationid']);
 				$db_opmtypes = DBSelect($sql);
 				if($db_opmtype = DBfetch($db_opmtypes)){
 					$operation_data['mediatypeid'] = $db_opmtype['mediatypeid'];
@@ -4753,7 +4753,7 @@
 							' FROM media_type mt, media m '.
 							' WHERE '.DBin_node('mt.mediatypeid').
 								' AND m.mediatypeid=mt.mediatypeid '.
-								' AND m.userid='.$new_operation['objectid'].
+								' AND m.userid='.zbx_dbstr($new_operation['objectid']).
 								' AND m.active='.ACTION_STATUS_ENABLED.
 							' ORDER BY mt.description';
 					$db_mediatypes = DBselect($sql);
@@ -4781,8 +4781,8 @@
 							' FROM media_type mt,media m '.
 							' WHERE '.DBin_node('mt.mediatypeid').
 								' AND mt.mediatypeid=m.mediatypeid '.
-								' AND m.userid='.$new_operation['objectid'].
-								($new_operation['mediatypeid'] ? ' AND m.mediatypeid='.$new_operation['mediatypeid'] : '').
+								' AND m.userid='.zbx_dbstr($new_operation['objectid']).
+								($new_operation['mediatypeid'] ? ' AND m.mediatypeid='.zbx_dbstr($new_operation['mediatypeid']) : '').
 								' AND m.active='.ACTION_STATUS_ENABLED.
 							' ORDER BY mt.description,m.sendto';
 					$db_medias = DBselect($sql);
@@ -4847,7 +4847,7 @@
 				$tblOper->addItem(new CVar('new_operation[shortdata]',''));
 				$tblOper->addItem(new CVar('new_operation[longdata]',''));
 
-				if($object_name= DBfetch(DBselect('select name FROM groups WHERE groupid='.$new_operation['objectid']))){
+				if($object_name= DBfetch(DBselect('select name FROM groups WHERE groupid='.zbx_dbstr($new_operation['objectid'])))){
 					$object_name = $object_name['name'];
 				}
 				$tblNewOperation->addRow(array(S_GROUP, array(
@@ -4866,7 +4866,7 @@
 				$tblOper->addItem(new CVar('new_operation[shortdata]',''));
 				$tblOper->addItem(new CVar('new_operation[longdata]',''));
 
-				if($object_name= DBfetch(DBselect('select name FROM groups WHERE groupid='.$new_operation['objectid']))){
+				if($object_name= DBfetch(DBselect('select name FROM groups WHERE groupid='.zbx_dbstr($new_operation['objectid'])))){
 					$object_name = $object_name['name'];
 				}
 				$tblNewOperation->addRow(array(S_GROUP, array(
@@ -4886,7 +4886,7 @@
 				$tblOper->addItem(new CVar('new_operation[longdata]',''));
 
 				if($object_name= DBfetch(DBselect('SELECT host FROM hosts '.
-					' WHERE status='.HOST_STATUS_TEMPLATE.' AND hostid='.$new_operation['objectid'])))
+					' WHERE status='.HOST_STATUS_TEMPLATE.' AND hostid='.zbx_dbstr($new_operation['objectid']))))
 				{
 					$object_name = $object_name['host'];
 				}
@@ -4907,7 +4907,7 @@
 				$tblOper->addItem(new CVar('new_operation[longdata]',''));
 
 				if($object_name= DBfetch(DBselect('SELECT host FROM hosts '.
-					' WHERE status='.HOST_STATUS_TEMPLATE.' AND hostid='.$new_operation['objectid'])))
+					' WHERE status='.HOST_STATUS_TEMPLATE.' AND hostid='.zbx_dbstr($new_operation['objectid']))))
 				{
 					$object_name = $object_name['host'];
 				}
@@ -5110,7 +5110,7 @@
 		$password	= get_request('password','');
 
 		if(isset($_REQUEST['mediatypeid']) && !isset($_REQUEST['form_refresh'])){
-			$result = DBselect('select * FROM media_type WHERE mediatypeid='.$_REQUEST['mediatypeid']);
+			$result = DBselect('select * FROM media_type WHERE mediatypeid='.zbx_dbstr($_REQUEST['mediatypeid']));
 
 			$row = DBfetch($result);
 			$mediatypeid	= $row['mediatypeid'];
@@ -5202,7 +5202,7 @@
 		if(isset($_REQUEST['screenid'])){
 			$result=DBselect('SELECT screenid,name,hsize,vsize '.
 						' FROM screens g '.
-						' WHERE screenid='.$_REQUEST['screenid']);
+						' WHERE screenid='.zbx_dbstr($_REQUEST['screenid']));
 			$row=DBfetch($result);
 			$frm_title = S_SCREEN.' "'.$row['name'].'"';
 		}
@@ -5701,7 +5701,7 @@
 			$host_groups = zbx_objectValues($host_groups, 'groupid');
 
 // read profile
-			$db_profiles = DBselect('SELECT * FROM hosts_profiles WHERE hostid='.$_REQUEST['hostid']);
+			$db_profiles = DBselect('SELECT * FROM hosts_profiles WHERE hostid='.zbx_dbstr($_REQUEST['hostid']));
 
 			$useprofile = 'no';
 			$db_profile = DBfetch($db_profiles);
@@ -5724,7 +5724,7 @@
 // BEGIN: HOSTS PROFILE EXTENDED Section
 			$useprofile_ext = 'no';
 
-			$db_profiles_alt = DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.$_REQUEST['hostid']);
+			$db_profiles_alt = DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.zbx_dbstr($_REQUEST['hostid']));
 			if($ext_host_profiles = DBfetch($db_profiles_alt)){
 				$useprofile_ext = 'yes';
 			}
@@ -5916,7 +5916,7 @@
 
 			$sql = 'SELECT * '.
 					' FROM items '.
-					' WHERE hostid='.$_REQUEST['hostid'].
+					' WHERE hostid='.zbx_dbstr($_REQUEST['hostid']).
 						' AND templateid=0 '.
 					' ORDER BY description';
 			$host_items_res = DBselect($sql);
@@ -5936,7 +5936,7 @@
 
 			$sql = 'SELECT DISTINCT t.* '.
 					' FROM triggers t, items i, functions f'.
-					' WHERE i.hostid='.$_REQUEST['hostid'].
+					' WHERE i.hostid='.zbx_dbstr($_REQUEST['hostid']).
 						' AND f.itemid=i.itemid '.
 						' AND t.triggerid=f.triggerid '.
 						' AND '.DBcondition('t.triggerid', $available_triggers).
@@ -5965,7 +5965,7 @@
 							' AND gi.graphid=g.graphid '.
 							' AND g.templateid=0 '.
 							' AND i.itemid=gi.itemid '.
-							' AND i.hostid='.$_REQUEST['hostid'].
+							' AND i.hostid='.zbx_dbstr($_REQUEST['hostid']).
 						' ORDER BY g.name';
 
 			$host_graph_res = DBselect($sql);
@@ -6137,7 +6137,7 @@
 
 		$sql_fields = implode(', ', array_keys($table_titles)); //generate string of fields to get from DB
 
-		$sql = 'SELECT '.$sql_fields.' FROM hosts_profiles WHERE hostid='.$_REQUEST['hostid'];
+		$sql = 'SELECT '.$sql_fields.' FROM hosts_profiles WHERE hostid='.zbx_dbstr($_REQUEST['hostid']);
 		$result = DBselect($sql);
 
 		if($row=DBfetch($result)) {
@@ -6179,7 +6179,7 @@
 
 		$sql_fields = implode(', ', array_keys($table_titles)); //generate string of fields to get from DB
 
-		$result=DBselect('SELECT '.$sql_fields.' FROM hosts_profiles_ext WHERE hostid='.$_REQUEST['hostid']);
+		$result=DBselect('SELECT '.$sql_fields.' FROM hosts_profiles_ext WHERE hostid='.zbx_dbstr($_REQUEST['hostid']));
 
 		if($row=DBfetch($result)) {
 			foreach($row as $key => $value) {
@@ -6260,7 +6260,7 @@
 		else{
 			$sql = 'SELECT DISTINCT h.hostid,h.host '.
 				' FROM hosts h,hosts_templates ht'.
-				' WHERE (ht.templateid='.$_REQUEST['hostid'].
+				' WHERE (ht.templateid='.zbx_dbstr($_REQUEST['hostid']).
 					' AND h.hostid=ht.hostid'.
 					' AND h.status IN ('.HOST_STATUS_MONITORED.','.HOST_STATUS_NOT_MONITORED.','.HOST_STATUS_TEMPLATE.') '.
 					' AND '.DBcondition('h.hostid',$available_hosts).' )'.
@@ -6278,7 +6278,7 @@
 			' FROM hosts h, hosts_groups hg'.
  			' WHERE ( h.status IN ('.HOST_STATUS_MONITORED.','.HOST_STATUS_NOT_MONITORED.','.HOST_STATUS_TEMPLATE.') '.
  				' AND '.DBcondition('h.hostid',$available_hosts).
-				' AND hg.groupid='.$selected_grp.
+				' AND hg.groupid='.zbx_dbstr($selected_grp).
 				' AND h.hostid=hg.hostid)'.
 				' OR '.DBcondition('h.hostid', $hosts_in_tpl).
  			' ORDER BY h.host';
@@ -6327,7 +6327,7 @@
 		$frm_title = 'New system map';
 
 		if(isset($_REQUEST['sysmapid'])){
-			$result=DBselect('SELECT * FROM sysmaps WHERE sysmapid='.$_REQUEST['sysmapid']);
+			$result=DBselect('SELECT * FROM sysmaps WHERE sysmapid='.zbx_dbstr($_REQUEST['sysmapid']));
 			$row=DBfetch($result);
 			$frm_title = 'System map: "'.$row['name'].'"';
 		}
@@ -6417,7 +6417,7 @@
 
 		$sql = 'SELECT name '.
 				' FROM scripts '.
-				' WHERE scriptid='.$scriptid;
+				' WHERE scriptid='.zbx_dbstr($scriptid);
 		$script_info = DBfetch(DBselect($sql));
 
 		$frmResult = new CFormTable($script_info['name'].': '.script_make_command($scriptid,$hostid));
@@ -6439,7 +6439,7 @@
 			$sql = 'SELECT re.* '.
 				' FROM regexps re '.
 				' WHERE '.DBin_node('re.regexpid').
-					' AND re.regexpid='.$_REQUEST['regexpid'];
+					' AND re.regexpid='.zbx_dbstr($_REQUEST['regexpid']);
 			$regexp = DBfetch(DBSelect($sql));
 
 			$frm_title .= ' ['.$regexp['name'].']';
@@ -6451,7 +6451,7 @@
 			$sql = 'SELECT e.* '.
 					' FROM expressions e '.
 					' WHERE '.DBin_node('e.expressionid').
-						' AND e.regexpid='.$regexp['regexpid'].
+						' AND e.regexpid='.zbx_dbstr($regexp['regexpid']).
 					' ORDER BY e.expression_type';
 
 			$db_exps = DBselect($sql);
@@ -6595,7 +6595,7 @@
 			$sql = 'SELECT e.* '.
 					' FROM expressions e '.
 					' WHERE '.DBin_node('e.expressionid').
-						' AND e.regexpid='.$_REQUEST['regexpid'].
+						' AND e.regexpid='.zbx_dbstr($_REQUEST['regexpid']).
 					' ORDER BY e.expression_type';
 
 			$db_exps = DBselect($sql);
Index: frontends/php/include/maps.inc.php
===================================================================
--- frontends/php/include/maps.inc.php	(revision 38884)
+++ frontends/php/include/maps.inc.php	(working copy)
@@ -82,7 +82,7 @@
 
 		$sql = 'SELECT * '.
 				' FROM sysmaps_elements '.
-				' WHERE sysmapid='.$sysmapid.
+				' WHERE sysmapid='.zbx_dbstr($sysmapid).
 					' AND '.DBin_node('sysmapid', $nodes);
 		$db_result = DBselect($sql);
 		$available_hosts = get_accessible_hosts_by_user($USER_DETAILS,$perm,PERM_RES_IDS_ARRAY,get_current_nodeid(true));
@@ -117,7 +117,7 @@
 	}
 
 	function get_sysmap_by_sysmapid($sysmapid){
-		$row = DBfetch(DBselect('SELECT * FROM sysmaps WHERE sysmapid='.$sysmapid));
+		$row = DBfetch(DBselect('SELECT * FROM sysmaps WHERE sysmapid='.zbx_dbstr($sysmapid)));
 		if($row){
 			return	$row;
 		}
@@ -126,7 +126,7 @@
 	}
 
 	function get_sysmaps_element_by_selementid($selementid){
-		$sql='select * FROM sysmaps_elements WHERE selementid='.$selementid;
+		$sql='select * FROM sysmaps_elements WHERE selementid='.zbx_dbstr($selementid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row){
@@ -144,7 +144,7 @@
 		$sysmapid=get_dbid('sysmaps','sysmapid');
 
 		$result=DBexecute('insert into sysmaps (sysmapid,name,width,height,backgroundid,highlight,label_type,label_location)'.
-			' VALUES ('.$sysmapid.','.zbx_dbstr($name).','.$width.','.$height.','.$backgroundid.','.$highlight.','.$label_type.','.$label_location.')');
+			' VALUES ('.$sysmapid.','.zbx_dbstr($name).','.zbx_dbstr($width).','.zbx_dbstr($height).','.zbx_dbstr($backgroundid).','.zbx_dbstr($highlight).','.zbx_dbstr($label_type).','.zbx_dbstr($label_location).')');
 
 		if(!$result)
 			return $result;
@@ -155,9 +155,9 @@
 // Update System Map
 
 	function update_sysmap($sysmapid,$name,$width,$height,$backgroundid,$highlight,$label_type,$label_location){
-		return	DBexecute('UPDATE sysmaps SET name='.zbx_dbstr($name).',width='.$width.',height='.$height.','.
-			'backgroundid='.$backgroundid.',highlight='.$highlight.',label_type='.$label_type.','.
-			'label_location='.$label_location.' WHERE sysmapid='.$sysmapid);
+		return	DBexecute('UPDATE sysmaps SET name='.zbx_dbstr($name).',width='.zbx_dbstr($width).',height='.zbx_dbstr($height).','.
+			'backgroundid='.zbx_dbstr($backgroundid).',highlight='.zbx_dbstr($highlight).',label_type='.zbx_dbstr($label_type).','.
+			'label_location='.zbx_dbstr($label_location).' WHERE sysmapid='.zbx_dbstr($sysmapid));
 	}
 
 // Delete System Map
@@ -212,9 +212,9 @@
 
 		$result&=DBexecute('INSERT INTO sysmaps_links '.
 			' (linkid,sysmapid,label,selementid1,selementid2,drawtype,color) '.
-			' VALUES ('.$linkid.','.$link['sysmapid'].','.zbx_dbstr($link['label']).','.
-						$link['selementid1'].','.$link['selementid2'].','.
-						$link['drawtype'].','.zbx_dbstr($link['color']).')');
+			' VALUES ('.$linkid.','.zbx_dbstr($link['sysmapid']).','.zbx_dbstr($link['label']).','.
+						zbx_dbstr($link['selementid1']).','.zbx_dbstr($link['selementid2']).','.
+						zbx_dbstr($link['drawtype']).','.zbx_dbstr($link['color']).')');
 
 		if(!$result)
 			return $result;
@@ -251,13 +251,13 @@
 		}
 
 		$result&=DBexecute('UPDATE sysmaps_links SET '.
-							' sysmapid='.$link['sysmapid'].', '.
+							' sysmapid='.zbx_dbstr($link['sysmapid']).', '.
 							' label='.zbx_dbstr($link['label']).', '.
-							' selementid1='.$link['selementid1'].', '.
-							' selementid2='.$link['selementid2'].', '.
-							' drawtype='.$link['drawtype'].', '.
+							' selementid1='.zbx_dbstr($link['selementid1']).', '.
+							' selementid2='.zbx_dbstr($link['selementid2']).', '.
+							' drawtype='.zbx_dbstr($link['drawtype']).', '.
 							' color='.zbx_dbstr($link['color']).
-						' WHERE linkid='.$link['linkid']);
+						' WHERE linkid='.zbx_dbstr($link['linkid']));
 	return	$result;
 	}
 
@@ -273,7 +273,7 @@
 	function get_link_triggers($linkid){
 		$triggers = array();
 
-		$sql = 'SELECT * FROM sysmaps_link_triggers WHERE linkid='.$linkid;
+		$sql = 'SELECT * FROM sysmaps_link_triggers WHERE linkid='.zbx_dbstr($linkid);
 		$res = DBselect($sql);
 
 		while($rows = DBfetch($res)){
@@ -285,7 +285,7 @@
 	function add_link_trigger($linkid,$triggerid,$drawtype,$color){
 		$linktriggerid=get_dbid("sysmaps_link_triggers","linktriggerid");
 		$sql = 'INSERT INTO sysmaps_link_triggers (linktriggerid,linkid,triggerid,drawtype,color) '.
-					" VALUES ($linktriggerid,$linkid,$triggerid,$drawtype,".zbx_dbstr($color).')';
+					' VALUES ('.zbx_dbstr($linktriggerid).','.zbx_dbstr($linkid).','.zbx_dbstr($triggerid).','.zbx_dbstr($drawtype).','.zbx_dbstr($color).')';
 	return DBexecute($sql);
 	}
 
@@ -296,7 +296,7 @@
 	}
 
 	function delete_link_trigger($linkid,$triggerid){
-	return DBexecute('DELETE FROM sysmaps_link_triggers WHERE linkid='.$linkid.' AND triggerid='.$triggerid);
+	return DBexecute('DELETE FROM sysmaps_link_triggers WHERE linkid='.zbx_dbstr($linkid).' AND triggerid='.zbx_dbstr($triggerid));
 	}
 
 	function delete_all_link_triggers($linkids){
@@ -323,7 +323,7 @@
 
 		$db_elements = DBselect('SELECT elementid, elementtype '.
 						' FROM sysmaps_elements '.
-						' WHERE sysmapid='.$elementid);
+						' WHERE sysmapid='.zbx_dbstr($elementid));
 
 		while($element = DBfetch($db_elements))
 		{
@@ -367,11 +367,11 @@
 		$result = DBexecute('INSERT INTO sysmaps_elements '.
 							'(selementid,sysmapid,elementid,elementtype,label,label_location,'.
 							'iconid_off,iconid_on,iconid_unknown,iconid_maintenance,iconid_disabled,x,y,url)'.
-						' VALUES ('.$selementid.','.$selement['sysmapid'].','.$selement['elementid'].','.
-									$selement['elementtype'].','.zbx_dbstr($selement['label']).','.$selement['label_location'].','.
-									$selement['iconid_off'].','.$selement['iconid_on'].','.$selement['iconid_unknown'].','.
-									$selement['iconid_maintenance'].','.$selement['iconid_disabled'].','.
-									$selement['x'].','.$selement['y'].','.zbx_dbstr($selement['url']).')');
+						' VALUES ('.$selementid.','.zbx_dbstr($selement['sysmapid']).','.zbx_dbstr($selement['elementid']).','.
+							zbx_dbstr($selement['elementtype']).','.zbx_dbstr($selement['label']).','.zbx_dbstr($selement['label_location']).','.
+							zbx_dbstr($selement['iconid_off']).','.zbx_dbstr($selement['iconid_on']).','.zbx_dbstr($selement['iconid_unknown']).','.
+							zbx_dbstr($selement['iconid_maintenance']).','.zbx_dbstr($selement['iconid_disabled']).','.
+							zbx_dbstr($selement['x']).','.zbx_dbstr($selement['y']).','.zbx_dbstr($selement['url']).')');
 
 		if(!$result)
 			return $result;
@@ -410,19 +410,19 @@
 		}
 
 		return	DBexecute('UPDATE sysmaps_elements '.
-					'SET elementid='.$selement['elementid'].', '.
-						' elementtype='.$selement['elementtype'].', '.
+					'SET elementid='.zbx_dbstr($selement['elementid']).', '.
+						' elementtype='.zbx_dbstr($selement['elementtype']).', '.
 						' label='.zbx_dbstr($selement['label']).', '.
-						' label_location='.$selement['label_location'].', '.
-						' x='.$selement['x'].', '.
-						' y='.$selement['y'].', '.
-						' iconid_off='.$selement['iconid_off'].', '.
-						' iconid_on='.$selement['iconid_on'].', '.
-						' iconid_unknown='.$selement['iconid_unknown'].', '.
-						' iconid_maintenance='.$selement['iconid_maintenance'].', '.
-						' iconid_disabled='.$selement['iconid_disabled'].', '.
+						' label_location='.zbx_dbstr($selement['label_location']).', '.
+						' x='.zbx_dbstr($selement['x']).', '.
+						' y='.zbx_dbstr($selement['y']).', '.
+						' iconid_off='.zbx_dbstr($selement['iconid_off']).', '.
+						' iconid_on='.zbx_dbstr($selement['iconid_on']).', '.
+						' iconid_unknown='.zbx_dbstr($selement['iconid_unknown']).', '.
+						' iconid_maintenance='.zbx_dbstr($selement['iconid_maintenance']).', '.
+						' iconid_disabled='.zbx_dbstr($selement['iconid_disabled']).', '.
 						' url='.zbx_dbstr($selement['url']).
-					' WHERE selementid='.$selement['selementid']);
+					' WHERE selementid='.zbx_dbstr($selement['selementid']));
 	}
 
 	/******************************************************************************
@@ -718,7 +718,7 @@
 	}
 
 	function get_png_by_selementid($selementid){
-		$selement = DBfetch(DBselect('SELECT * FROM sysmaps_elements WHERE selementid='.$selementid));
+		$selement = DBfetch(DBselect('SELECT * FROM sysmaps_elements WHERE selementid='.zbx_dbstr($selementid)));
 		if(!$selement)	return FALSE;
 
 	return get_png_by_selement($selement);
@@ -890,14 +890,14 @@
 						zbx_strstr($label, '{HOST.CONN}'))
 				{
 					if($db_element['elementtype'] == SYSMAP_ELEMENT_TYPE_HOST){
-						$sql =' SELECT * FROM hosts WHERE hostid='.$db_element['elementid'];
+						$sql =' SELECT * FROM hosts WHERE hostid='.zbx_dbstr($db_element['elementid']);
 					}
 					else if($db_element['elementtype'] == SYSMAP_ELEMENT_TYPE_TRIGGER)
 						$sql =	'SELECT h.* '.
 							' FROM hosts h,items i,functions f '.
 							' WHERE h.hostid=i.hostid '.
 								' AND i.itemid=f.itemid '.
-								' AND f.triggerid='.$db_element['elementid'];
+								' AND f.triggerid='.zbx_dbstr($db_element['elementid']);
 					else{
 // Should never be here
 					}
@@ -1012,7 +1012,7 @@
 			if(0 == strcmp($function, 'last')){
 				$sql = 'SELECT value '.
 						' FROM '.$history_table.
-						' WHERE itemid='.$db_item['itemid'].
+						' WHERE itemid='.zbx_dbstr($db_item['itemid']).
 						' ORDER BY '.$order_field.' DESC';
 
 				$result = DBselect($sql, 1);
@@ -1042,7 +1042,7 @@
 				$sql = 'SELECT '.$function.'(value) as value '.
 						' FROM '.$history_table.
 						' WHERE clock>'.$now.
-							' AND itemid='.$db_item['itemid'];
+							' AND itemid='.zbx_dbstr($db_item['itemid']);
 
 				$result = DBselect($sql);
 				if(NULL == ($row = DBfetch($result)) || is_null($row['value']))
@@ -1133,7 +1133,7 @@
 		case SYSMAP_ELEMENT_TYPE_MAP:
 			$sql = 'SELECT DISTINCT elementtype,elementid'.
 					' FROM sysmaps_elements'.
-					' WHERE sysmapid='.$db_element['elementid'];
+					' WHERE sysmapid='.zbx_dbstr($db_element['elementid']);
 			$db_mapselements = DBselect($sql);
 			while($db_mapelement = DBfetch($db_mapselements)){
 				get_map_elements($db_mapelement, $elements);
